unit UDemo;

interface

uses
  Windows,  SysUtils, Classes, Controls, Forms,
  Grids, DBNGrid, DB, DBTables, ExtCtrls, DBGrids,
  StdCtrls, Buttons, Graphics;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    DBNGrid1: TDBNGrid;
    DataSource1: TDataSource;
    Table1: TTable;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Bevel1: TBevel;
    Label4: TLabel;
    procedure DBNGrid1CaptionClick(aCaption: Integer);
    procedure DBNGrid1SelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure DBNGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure DBNGrid1ScrollBar(aScrollBar: TScrollStyle);
    procedure DBNGrid1DrawColorDataCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; var GridCanvas: TCanvas;
      State: TGridDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.DBNGrid1CaptionClick(aCaption: Integer);
var i : Integer;
begin
  for i := 0 to DBNGrid1.Columns.Count-1 do
      DBNGrid1.Columns.Items[i].Color:= clWindow;
      
  DBNGrid1.Columns.Items[aCaption].Color:= $00FFFF80;

// mousetocell

end;

procedure TForm1.DBNGrid1SelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  Label2.Caption := 'Selected Cell Row:'+IntToStr(Row)+'  Col:'+IntToStr(Col);
end;

procedure TForm1.DBNGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Label1.Caption := 'Mouse position X:'+IntToStr(x)+'  Y:'+IntToStr(y);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  DBNGrid1.VertScrollBarAlign := sbvLeft;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  DBNGrid1.VertScrollBarAlign := sbvRight;
end;

procedure TForm1.DBNGrid1ScrollBar(aScrollBar: TScrollStyle);
begin
  case aScrollBar of
    ssVertical:   Label4.Caption := 'Vertical Scroll Pressed';
    ssHorizontal: Label4.Caption := 'Horizontal Scroll Pressed';
  end;
end;

procedure TForm1.DBNGrid1DrawColorDataCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  var GridCanvas: TCanvas; State: TGridDrawState);
  var MyRect : TRECT;
begin
  MyRect := Rect;
  MyRect.Top := Rect.Top + 2;
  MyRect.Left := Rect.Left + 2;

  if Table1.FieldByName('Salary').asFloat > 26000 then
  begin
    GridCanvas.FillRect(Rect);
    GridCanvas.Font.Color := clGreen;
    DrawText(GridCanvas.Handle,
             PChar(DBNGrid1.Fields[DataCol].DisplayText),
             -1,
             MyRect,
             DT_LEFT );
  end else
  begin
    GridCanvas.FillRect(Rect);
    GridCanvas.Font.Color := clRed;
    DrawText(GridCanvas.Handle,
             PChar(DBNGrid1.Fields[DataCol].DisplayText),
             -1,
             MyRect,
             DT_LEFT );
  end;
end;

end.



